* Program   : Jul2Cal()
* Version   : dBASE IV 1.1
* Author(s) : "UNKNOWN"
*             modified by Luis A. Castro to dBASE II
*             modified by "You Know Who" to dBASE IV
* Date      : 1/12/83, 10/27/83, 11/20/83, 01/02/84, 11/01/91
* Note      : Converts from Julian to calendar date
*
*      name      typ len    description
*     ---------- --- ---  --------------------
*     calendar    N   5   Julian date
*     mdate       D   8   calendar date
*

FUNCTION jul2cal
PARAMETER julian

SET TALK OFF

IF julian=0
   RETURN {}
ENDIF

* -- Convert from Julian to calendar
m_year = INT( julian / 365.26 ) + 1
m_day  = julian + INT( 395.25 - 365.25 * m_year )

* ---Calculate extra day for leap year
IF INT( m_year / 4 ) * 4 = m_year
   m_leapday = 1
ELSE
   m_leapday = 2
ENDIF

* ---Calculate actual number of days.
IF m_day > ( 91 - m_leapday )
   m_day = m_day + m_leapday
ENDIF

* ---Generate month, day, and year.
m_month = INT( m_day / 30.57 )
m_day = m_day - INT( 30.57 * m_month )
IF m_month > 12
   m_month = 1
   m_year = m_year + 1
ENDIF

* ---Set-up the calendar date.
calendar = CTOD(STR(m_month,2)+"/"+STR(m_day,2)+"/"+STR(m_year,2))

SET TALK ON

RETURN calendar
